#!/bin/sh

#打ipa包，用企业证书强制签名

# xcode version
XCODE_BUILD_VERSION=$(xcodebuild -version)

#输入用户配置信息
while getopts ":s:t:c:d:p:i:b:r:l:" opt; do
    case $opt in
        s)
        __SCHEME_NAME=$OPTARG;;
        t)
        __PROJECT_NAME=$OPTARG
        __BUILD_TARGET=$OPTARG;;
        c)
        __BUILD_CONFIGURATION=$OPTARG;;
        d)
        __BUILD_METHOD_NAME=$OPTARG;;
        p)
        provision_path=$OPTARG;;
        i)
        cert_name=$OPTARG;;
        b)
        bundleID=$OPTARG;;
        r)
        serverIP=$OPTARG;;
        l)
        productDir=$OPTARG;;
        ?)
        echo "xcode_version: $XCODE_BUILD_VERSION, result: 0"
        exit 1;;
    esac
done

# ===============================自动打包部分=============================

# 已经指定Target的Info.plist文件路径 【配置Info.plist的名称】
__CURRENT_INFO_PLIST_NAME="Info.plist"
# 获取 Info.plist 路径  【配置Info.plist的路径】 需检查此目录下是否存在plist 不过不存在 可以修改路径 或者把plist文件拷贝到此目录下
__CURRENT_INFO_PLIST_PATH="${__PROJECT_NAME}/${__CURRENT_INFO_PLIST_NAME}"
echo "plist path = $__CURRENT_INFO_PLIST_PATH"
# 获取版本号
__BUNDLE_VERSION=`/usr/libexec/PlistBuddy -c "Print CFBundleShortVersionString" ${__CURRENT_INFO_PLIST_PATH}`
#__BUNDLE_VERSION=`/usr/libexec/PlistBuddy -c "Print ApplicationProperties:CFBundleShortVersionString" ${__CURRENT_INFO_PLIST_PATH}`
#__BUNDLE_VERSION="1.0.0"
# 获取编译版本号
__BUNDLE_BUILD_VERSION=`/usr/libexec/PlistBuddy -c "Print CFBundleVersion" ${__CURRENT_INFO_PLIST_PATH}`
#__BUNDLE_BUILD_VERSION="202109081720"#`/usr/libexec/PlistBuddy -c "Print CFBundleVersion" ${__CURRENT_INFO_PLIST_PATH}`

echo "build 1 version = $__BUNDLE_VERSIONH"
echo "build 1 version123 = $__BUNDLE_BUILD_VERSION"

# Xcode11 以上版本
#if [[ $XCODE_BUILD_VERSION =~ "Xcode 11" || $XCODE_BUILD_VERSION =~ "Xcode11" ]]; then
#  __BUNDLE_VERSION_TAG="MARKETING_VERSION"
#  __BUNDLE_BUILD_VERSION_TAG="CURRENT_PROJECT_VERSION"
#  __PROJECT_ROOT_PATH=`find . -name *.xcodeproj`
#  __PBXPROJ_PATH="$__PROJECT_ROOT_PATH/project.pbxproj"
#  __BUNDLE_VERSION_11=$(grep "${__BUNDLE_VERSION_TAG}" $__PBXPROJ_PATH | head -1 | awk -F '=' '{print $2}' | awk -F ';' '{print $1}' | sed s/[[:space:]]//g)
##__BUNDLE_VERSION_11="1.0.0"
#  __BUNDLE_BUILD_VERSION_11=$(grep "${__BUNDLE_BUILD_VERSION_TAG}" $__PBXPROJ_PATH | head -1 | awk -F '=' '{print $2}' | awk -F ';' '{print $1}' | sed s/[[:space:]]//g)
##__BUNDLE_BUILD_VERSION_11="202109081720"
#
#  if [[ -n "$__BUNDLE_VERSION_11" ]]; then
#    __BUNDLE_VERSION="$__BUNDLE_VERSION_11";
#  fi
#
#  if [[ -n "$__BUNDLE_BUILD_VERSION_11" ]]; then
#    __BUNDLE_BUILD_VERSION="$__BUNDLE_BUILD_VERSION_11";
#  fi
#fi

#__BUNDLE_VERSION="1.0.0"
echo "build version = $__BUNDLE_VERSIONH"
echo "build version123 = $__BUNDLE_BUILD_VERSION"
# current_date="$(date +%Y%m%d_%H%M%S)"
# ProductDir="${productDir}/${current_date}"

`test -d "${productDir}"`
# 构建产物目录, 指定输出文件目录不存在则创建
if [ $? -ne 0 ]; then
  mkdir -pv ${productDir}
fi

# 归档文件路径
EXPORT_ARCHIVE_PATH="${productDir}/${__SCHEME_NAME}.xcarchive"
# ipa 导出路径
EXPORT_IPA_PATH="${productDir}"

# 此处改为你电脑的登录账号的密码
KEYCHAIN_PASSWORD="xujiawen456"
KEYCHAIN_NAME="login.keychain"
security set-key-partition-list -S apple: -s -k $KEYCHAIN_PASSWORD $KEYCHAIN_NAME

#
# Extract the profile UUID from the checked in Provisioning Profile.
#
uuid=`/usr/libexec/plistbuddy -c Print:UUID /dev/stdin <<< \
        \`security cms -D -i ${provision_path}\``

#
# Copy the profile to the location XCode expects to find it and start the build,
# specifying which profile and signing identity to use for the archived app
#
cp -f ${provision_path} \
        "$HOME/Library/MobileDevice/Provisioning Profiles/$uuid.mobileprovision"


# step 1. Clean
xcodebuild clean  -workspace ${__PROJECT_NAME}.xcworkspace \
-scheme ${__SCHEME_NAME} \
-configuration ${__BUILD_CONFIGURATION}

# step 2. Archive
xcodebuild archive  -workspace ${__PROJECT_NAME}.xcworkspace \
-scheme ${__SCHEME_NAME} \
-configuration ${__BUILD_CONFIGURATION} \
-archivePath ${EXPORT_ARCHIVE_PATH} \
#CFBundleVersion=${__BUNDLE_BUILD_VERSION} \#
#-destination generic/platform=ios \#
#PROVISIONING_PROFILE="${uuid}" \
#CODE_SIGN_IDENTITY="${cert_name}" \
#PRODUCT_BUNDLE_IDENTIFIER=${bundleID}

if test $? -eq 0; then
    echo "-------archive Success $?"
  else
    exit $?
  echo "--------archive Failed $?"
fi

 #导出IPA配置
function createExportOptionsPlist() {
  currentPath=`pwd`
  __EXPORT_OPTIONS_PLIST_PATH="${currentPath}/${__BUILD_METHOD_NAME}_ExportOptions.plist"
  echo "--------EXPORT_OPTIONS_PLIST_PATH $__EXPORT_OPTIONS_PLIST_PATH"
  if test -f "${__EXPORT_OPTIONS_PLIST_PATH}" ; then 
    rm ${__EXPORT_OPTIONS_PLIST_PATH}
  fi
  touch ${__EXPORT_OPTIONS_PLIST_PATH}
  echo "<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE plist PUBLIC "-//Apple//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd"><plist version="1.0"><dict></dict></plist>" > ${__EXPORT_OPTIONS_PLIST_PATH}
  #`/usr/libexec/PlistBuddy -c 'Add :compileBitcode string false' ${__EXPORT_OPTIONS_PLIST_PATH}`
  /usr/libexec/PlistBuddy -c "Add :manifest dict" ${__EXPORT_OPTIONS_PLIST_PATH}
  /usr/libexec/PlistBuddy -c "Add :manifest:appURL string ${serverIP}/${__SCHEME_NAME}.ipa" ${__EXPORT_OPTIONS_PLIST_PATH}
  /usr/libexec/PlistBuddy -c "Add :manifest:displayImageURL string $serverIP" ${__EXPORT_OPTIONS_PLIST_PATH}
  /usr/libexec/PlistBuddy -c "Add :manifest:fullSizeImageURL string $serverIP" ${__EXPORT_OPTIONS_PLIST_PATH}
  /usr/libexec/PlistBuddy -c "Add :provisioningProfiles dict" ${__EXPORT_OPTIONS_PLIST_PATH}
  /usr/libexec/PlistBuddy -c "Add :provisioningProfiles:$bundleID string $uuid" ${__EXPORT_OPTIONS_PLIST_PATH}
  /usr/libexec/PlistBuddy -c "Add :signingCertificate string $cert_name" ${__EXPORT_OPTIONS_PLIST_PATH}
}

createExportOptionsPlist

echo "--------createExportOptionsPlist\n"

echo "--------start export \n"

#开始导出ipa文件
xcodebuild -exportArchive -archivePath ${EXPORT_ARCHIVE_PATH} \
-exportPath ${EXPORT_IPA_PATH} \
-allowProvisioningUpdates \
-exportOptionsPlist ${__EXPORT_OPTIONS_PLIST_PATH}
#-destination generic/platform=ios \#



echo "--------end export \n ${EXPORT_IPA_PATH}"

if test $? -eq 0; then
  rm -r ${EXPORT_ARCHIVE_PATH}
  echo "--------exit 0"
  exit 0
else
  echo "--------exit else"
  exit $?
fi
